/**
 */
package tools.descartes.dni.dnimm3.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import tools.descartes.dni.dnimm3.AbstractAction;
import tools.descartes.dni.dnimm3.AddressableEntity;
import tools.descartes.dni.dnimm3.BranchAction;
import tools.descartes.dni.dnimm3.Common;
import tools.descartes.dni.dnimm3.CommunicatingApplication;
import tools.descartes.dni.dnimm3.ConstantDoubleVariable;
import tools.descartes.dni.dnimm3.ConstantLongVariable;
import tools.descartes.dni.dnimm3.DNIFactory;
import tools.descartes.dni.dnimm3.DNIPackage;
import tools.descartes.dni.dnimm3.DNIUnit;
import tools.descartes.dni.dnimm3.DataUnit;
import tools.descartes.dni.dnimm3.Dependency;
import tools.descartes.dni.dnimm3.Direction;
import tools.descartes.dni.dnimm3.DiscreteFunction;
import tools.descartes.dni.dnimm3.End;
import tools.descartes.dni.dnimm3.EndPerformance;
import tools.descartes.dni.dnimm3.EndPerformanceType;
import tools.descartes.dni.dnimm3.Entity;
import tools.descartes.dni.dnimm3.EntityAddress;
import tools.descartes.dni.dnimm3.EntityTypes;
import tools.descartes.dni.dnimm3.ExponentialFunction;
import tools.descartes.dni.dnimm3.FloatCoordinate;
import tools.descartes.dni.dnimm3.Flow;
import tools.descartes.dni.dnimm3.FlowRoute;
import tools.descartes.dni.dnimm3.FlowTraffic;
import tools.descartes.dni.dnimm3.Function;
import tools.descartes.dni.dnimm3.GenericFlowTraffic;
import tools.descartes.dni.dnimm3.GenericWorkload;
import tools.descartes.dni.dnimm3.Hop;
import tools.descartes.dni.dnimm3.IType;
import tools.descartes.dni.dnimm3.ITypedEntity;
import tools.descartes.dni.dnimm3.Identifier;
import tools.descartes.dni.dnimm3.Intermediate;
import tools.descartes.dni.dnimm3.IntermediatePerformance;
import tools.descartes.dni.dnimm3.IntermediatePerformanceType;
import tools.descartes.dni.dnimm3.Link;
import tools.descartes.dni.dnimm3.LinkPerformanceType;
import tools.descartes.dni.dnimm3.LinkType;
import tools.descartes.dni.dnimm3.LoopAction;
import tools.descartes.dni.dnimm3.NamedElement;
import tools.descartes.dni.dnimm3.NetworkConfiguration;
import tools.descartes.dni.dnimm3.NetworkInfrastructure;
import tools.descartes.dni.dnimm3.NetworkInterface;
import tools.descartes.dni.dnimm3.NetworkInterfacePerformanceType;
import tools.descartes.dni.dnimm3.NetworkInterfaceType;
import tools.descartes.dni.dnimm3.NetworkProtocol;
import tools.descartes.dni.dnimm3.NetworkStructure;
import tools.descartes.dni.dnimm3.NetworkTraffic;
import tools.descartes.dni.dnimm3.Node;
import tools.descartes.dni.dnimm3.NodeType;
import tools.descartes.dni.dnimm3.PerformanceLink;
import tools.descartes.dni.dnimm3.PerformanceNetworkInterface;
import tools.descartes.dni.dnimm3.PerformanceSdnNode;
import tools.descartes.dni.dnimm3.PerformanceSpecification;
import tools.descartes.dni.dnimm3.ProtocolLayer;
import tools.descartes.dni.dnimm3.ProtocolStack;
import tools.descartes.dni.dnimm3.ProtocolsRepository;
import tools.descartes.dni.dnimm3.RandomVariable;
import tools.descartes.dni.dnimm3.Route;
import tools.descartes.dni.dnimm3.RoutesRepository;
import tools.descartes.dni.dnimm3.SdnControlFlow;
import tools.descartes.dni.dnimm3.SdnController;
import tools.descartes.dni.dnimm3.SdnControllerApplication;
import tools.descartes.dni.dnimm3.SdnFlowRule;
import tools.descartes.dni.dnimm3.SdnNodePerformanceType;
import tools.descartes.dni.dnimm3.SequenceAction;
import tools.descartes.dni.dnimm3.Speed;
import tools.descartes.dni.dnimm3.SpeedUnit;
import tools.descartes.dni.dnimm3.StartAction;
import tools.descartes.dni.dnimm3.StopAction;
import tools.descartes.dni.dnimm3.Time;
import tools.descartes.dni.dnimm3.TimeUnit;
import tools.descartes.dni.dnimm3.TrafficSource;
import tools.descartes.dni.dnimm3.TransmitAction;
import tools.descartes.dni.dnimm3.UnitPrefix;
import tools.descartes.dni.dnimm3.Variable;
import tools.descartes.dni.dnimm3.WaitAction;
import tools.descartes.dni.dnimm3.Workload;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DNIPackageImpl extends EPackageImpl implements DNIPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass namedElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass identifierEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInfrastructureEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkStructureEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nodeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass intermediateEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkTrafficEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdnControlFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowTrafficEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass genericFlowTrafficEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass communicatingApplicationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trafficSourceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkConfigurationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass protocolsRepositoryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass protocolStackEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass protocolLayerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkProtocolEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass routesRepositoryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass directionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowRouteEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass routeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hopEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityAddressEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass addressableEntityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass workloadEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass genericWorkloadEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass branchActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sequenceActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass startActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stopActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass transmitActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass waitActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass performanceSpecificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass performanceLinkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass performanceNetworkInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdnFlowRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdnControllerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdnControllerApplicationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass commonEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdnEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass intermediatePerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endPerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass performanceSdnNodeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dniUnitEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass speedUnitEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataUnitEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeUnitEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dependencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass functionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass constantDoubleVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass constantLongVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass randomVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass floatCoordinateEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass discreteFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass exponentialFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityTypesEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iTypedEntityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nodeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endPerformanceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass intermediatePerformanceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdnNodePerformanceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInterfaceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInterfacePerformanceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkPerformanceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum unitPrefixEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum speedEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum timeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see tools.descartes.dni.dnimm3.DNIPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private DNIPackageImpl() {
		super(eNS_URI, DNIFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link DNIPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static DNIPackage init() {
		if (isInited) return (DNIPackage)EPackage.Registry.INSTANCE.getEPackage(DNIPackage.eNS_URI);

		// Obtain or create and register package
		DNIPackageImpl theDNIPackage = (DNIPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof DNIPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new DNIPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theDNIPackage.createPackageContents();

		// Initialize created meta-data
		theDNIPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theDNIPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(DNIPackage.eNS_URI, theDNIPackage);
		return theDNIPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNamedElement() {
		return namedElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNamedElement_Name() {
		return (EAttribute)namedElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNamedElement_Description() {
		return (EAttribute)namedElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIdentifier() {
		return identifierEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdentifier_Uid() {
		return (EAttribute)identifierEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdentifier_Uid_generated() {
		return (EAttribute)identifierEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntity() {
		return entityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInfrastructure() {
		return networkInfrastructureEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Traffic() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Structure() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Configuration() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_EntityTypes() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInfrastructure_DataCenterName() {
		return (EAttribute)networkInfrastructureEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInfrastructure_MetaModelVersion() {
		return (EAttribute)networkInfrastructureEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkStructure() {
		return networkStructureEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkStructure_Nodes() {
		return (EReference)networkStructureEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkStructure_Links() {
		return (EReference)networkStructureEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNode() {
		return nodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_Interfaces() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_Sdntype() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNode_IsPhysical() {
		return (EAttribute)nodeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNode_IsPhysical_derived() {
		return (EAttribute)nodeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_Hosts() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_IsHostedOn() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_End() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_Intermediate() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_EntityType() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEnd() {
		return endEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEnd_Performance() {
		return (EReference)endEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEnd_Software() {
		return (EReference)endEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEnd_Node() {
		return (EReference)endEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEnd_Name() {
		return (EAttribute)endEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntermediate() {
		return intermediateEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediate_Performance() {
		return (EReference)intermediateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediate_Node() {
		return (EReference)intermediateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntermediate_Name() {
		return (EAttribute)intermediateEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLink() {
		return linkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLink_Connects() {
		return (EReference)linkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLink_Performance() {
		return (EReference)linkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLink_Name_generated() {
		return (EAttribute)linkEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLink_EntityType() {
		return (EReference)linkEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInterface() {
		return networkInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterface_UsedProtocolStack() {
		return (EReference)networkInterfaceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterface_Performance() {
		return (EReference)networkInterfaceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterface_Node() {
		return (EReference)networkInterfaceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInterface_Name_generated() {
		return (EAttribute)networkInterfaceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterface_EntityType() {
		return (EReference)networkInterfaceEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkTraffic() {
		return networkTrafficEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkTraffic_Flows() {
		return (EReference)networkTrafficEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkTraffic_Software() {
		return (EReference)networkTrafficEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlow() {
		return flowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_SourceSoftware() {
		return (EReference)flowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_GeneratedTraffic() {
		return (EReference)flowEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_DestinationSoftware() {
		return (EReference)flowEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_DestinationAddresses() {
		return (EReference)flowEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdnControlFlow() {
		return sdnControlFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnControlFlow_ParentFlow() {
		return (EReference)sdnControlFlowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlowTraffic() {
		return flowTrafficEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowTraffic_Flow() {
		return (EReference)flowTrafficEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlowTraffic_Name() {
		return (EAttribute)flowTrafficEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGenericFlowTraffic() {
		return genericFlowTrafficEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericFlowTraffic_DataSize() {
		return (EReference)genericFlowTrafficEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCommunicatingApplication() {
		return communicatingApplicationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCommunicatingApplication_TrafficSources() {
		return (EReference)communicatingApplicationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCommunicatingApplication_DeployedOn() {
		return (EReference)communicatingApplicationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTrafficSource() {
		return trafficSourceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTrafficSource_Workload() {
		return (EReference)trafficSourceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTrafficSource_SoftwareComponent() {
		return (EReference)trafficSourceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkConfiguration() {
		return networkConfigurationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkConfiguration_ProtocolsAndStacks() {
		return (EReference)networkConfigurationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkConfiguration_Routes() {
		return (EReference)networkConfigurationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkConfiguration_Rules() {
		return (EReference)networkConfigurationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProtocolsRepository() {
		return protocolsRepositoryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolsRepository_Stacks() {
		return (EReference)protocolsRepositoryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolsRepository_Protocols() {
		return (EReference)protocolsRepositoryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProtocolStack() {
		return protocolStackEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolStack_Layers() {
		return (EReference)protocolStackEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProtocolLayer() {
		return protocolLayerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolLayer_Protocol() {
		return (EReference)protocolLayerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolLayer_IsCarriedBy() {
		return (EReference)protocolLayerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolLayer_Carries() {
		return (EReference)protocolLayerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkProtocol() {
		return networkProtocolEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_Mtu() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_HeadersLength() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRoutesRepository() {
		return routesRepositoryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoutesRepository_Routes() {
		return (EReference)routesRepositoryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoutesRepository_FlowRoutes() {
		return (EReference)routesRepositoryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoutesRepository_Directions() {
		return (EReference)routesRepositoryEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDirection() {
		return directionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDirection_OnNode() {
		return (EReference)directionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDirection_Flow() {
		return (EReference)directionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDirection_Via() {
		return (EReference)directionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDirection_Default() {
		return (EAttribute)directionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDirection_Probability() {
		return (EAttribute)directionEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlowRoute() {
		return flowRouteEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_Hops() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_Flow() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_Start() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_End() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlowRoute_Probability() {
		return (EAttribute)flowRouteEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRoute() {
		return routeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoute_Hops() {
		return (EReference)routeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoute_Start() {
		return (EReference)routeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoute_End() {
		return (EReference)routeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHop() {
		return hopEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHop_NextHop() {
		return (EReference)hopEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHop_Interfaceref() {
		return (EReference)hopEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntityAddress() {
		return entityAddressEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEntityAddress_Address() {
		return (EAttribute)entityAddressEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntityAddress_AddressGivenBy() {
		return (EReference)entityAddressEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAddressableEntity() {
		return addressableEntityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAddressableEntity_Addresses() {
		return (EReference)addressableEntityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWorkload() {
		return workloadEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGenericWorkload() {
		return genericWorkloadEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericWorkload_Actions() {
		return (EReference)genericWorkloadEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractAction() {
		return abstractActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBranchAction() {
		return branchActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchAction_Intern() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopAction() {
		return loopActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopAction_Intern() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopAction_NumIterations() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSequenceAction() {
		return sequenceActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSequenceAction_Intern() {
		return (EReference)sequenceActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStartAction() {
		return startActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStopAction() {
		return stopActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTransmitAction() {
		return transmitActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTransmitAction_FlowTraffic() {
		return (EReference)transmitActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWaitAction() {
		return waitActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getWaitAction_WaitTime() {
		return (EReference)waitActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPerformanceSpecification() {
		return performanceSpecificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPerformanceLink() {
		return performanceLinkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceLink_PropagationDelay() {
		return (EReference)performanceLinkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceLink_MaxSupportedBandwidth() {
		return (EReference)performanceLinkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceLink_EntityType() {
		return (EReference)performanceLinkEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPerformanceNetworkInterface() {
		return performanceNetworkInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerformanceNetworkInterface_IsUp() {
		return (EAttribute)performanceNetworkInterfaceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerformanceNetworkInterface_MTU() {
		return (EAttribute)performanceNetworkInterfaceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceNetworkInterface_PacketProcessingTime() {
		return (EReference)performanceNetworkInterfaceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceNetworkInterface_InterfaceThroughput() {
		return (EReference)performanceNetworkInterfaceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceNetworkInterface_EntityType() {
		return (EReference)performanceNetworkInterfaceEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdnFlowRule() {
		return sdnFlowRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnFlowRule_SdnSwitch() {
		return (EReference)sdnFlowRuleEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnFlowRule_Flow() {
		return (EReference)sdnFlowRuleEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdnFlowRule_ProbabilityHardware() {
		return (EAttribute)sdnFlowRuleEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdnFlowRule_ProbabilitySoftware() {
		return (EAttribute)sdnFlowRuleEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdnFlowRule_ProbabilityController() {
		return (EAttribute)sdnFlowRuleEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnFlowRule_ControllerApplication() {
		return (EReference)sdnFlowRuleEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdnController() {
		return sdnControllerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnController_Applications() {
		return (EReference)sdnControllerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnController_Nodes() {
		return (EReference)sdnControllerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdnControllerApplication() {
		return sdnControllerApplicationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnControllerApplication_BelongsTo() {
		return (EReference)sdnControllerApplicationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdnControllerApplication_IsDefault() {
		return (EAttribute)sdnControllerApplicationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnControllerApplication_ResponseDelay() {
		return (EReference)sdnControllerApplicationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIType() {
		return iTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCommon() {
		return commonEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSDN() {
		return sdnEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSDN_Performance() {
		return (EReference)sdnEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSDN_Controller() {
		return (EReference)sdnEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSDN_OpenFlowEndPoint() {
		return (EReference)sdnEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntermediatePerformance() {
		return intermediatePerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediatePerformance_ForwardingLatency() {
		return (EReference)intermediatePerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediatePerformance_ForwardingBandwidthBPS() {
		return (EReference)intermediatePerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediatePerformance_SwitchingCapacityPPS() {
		return (EReference)intermediatePerformanceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediatePerformance_EntityType() {
		return (EReference)intermediatePerformanceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndPerformance() {
		return endPerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndPerformance_SoftwareLayersDelay() {
		return (EReference)endPerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndPerformance_EntityType() {
		return (EReference)endPerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPerformanceSdnNode() {
		return performanceSdnNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceSdnNode_SoftwareSwitchingPerformance() {
		return (EReference)performanceSdnNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceSdnNode_HardwareSwitchingPerformance() {
		return (EReference)performanceSdnNodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPerformanceSdnNode_EntityType() {
		return (EReference)performanceSdnNodeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDNIUnit() {
		return dniUnitEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSpeedUnit() {
		return speedUnitEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSpeedUnit_Unit() {
		return (EAttribute)speedUnitEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSpeedUnit_Prefix() {
		return (EAttribute)speedUnitEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataUnit() {
		return dataUnitEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataUnit_Prefix() {
		return (EAttribute)dataUnitEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeUnit() {
		return timeUnitEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeUnit_Unit() {
		return (EAttribute)timeUnitEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDependency() {
		return dependencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDependency_Unit() {
		return (EReference)dependencyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVariable() {
		return variableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFunction() {
		return functionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConstantDoubleVariable() {
		return constantDoubleVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConstantDoubleVariable_Value() {
		return (EAttribute)constantDoubleVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConstantLongVariable() {
		return constantLongVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConstantLongVariable_Value() {
		return (EAttribute)constantLongVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRandomVariable() {
		return randomVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRandomVariable_Cdf() {
		return (EReference)randomVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFloatCoordinate() {
		return floatCoordinateEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFloatCoordinate_X() {
		return (EAttribute)floatCoordinateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFloatCoordinate_Y() {
		return (EAttribute)floatCoordinateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDiscreteFunction() {
		return discreteFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDiscreteFunction_Vals() {
		return (EReference)discreteFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExponentialFunction() {
		return exponentialFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getExponentialFunction_Lambda() {
		return (EAttribute)exponentialFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntityTypes() {
		return entityTypesEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntityTypes_Types() {
		return (EReference)entityTypesEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getITypedEntity() {
		return iTypedEntityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNodeType() {
		return nodeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNodeType_Entities() {
		return (EReference)nodeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndPerformanceType() {
		return endPerformanceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndPerformanceType_Entities() {
		return (EReference)endPerformanceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntermediatePerformanceType() {
		return intermediatePerformanceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediatePerformanceType_Entities() {
		return (EReference)intermediatePerformanceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdnNodePerformanceType() {
		return sdnNodePerformanceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSdnNodePerformanceType_Entities() {
		return (EReference)sdnNodePerformanceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInterfaceType() {
		return networkInterfaceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterfaceType_Entities() {
		return (EReference)networkInterfaceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInterfacePerformanceType() {
		return networkInterfacePerformanceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterfacePerformanceType_Entities() {
		return (EReference)networkInterfacePerformanceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLinkType() {
		return linkTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLinkType_Entities() {
		return (EReference)linkTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLinkPerformanceType() {
		return linkPerformanceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLinkPerformanceType_Entities() {
		return (EReference)linkPerformanceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getUnitPrefix() {
		return unitPrefixEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getSpeed() {
		return speedEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTime() {
		return timeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIFactory getDNIFactory() {
		return (DNIFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		namedElementEClass = createEClass(NAMED_ELEMENT);
		createEAttribute(namedElementEClass, NAMED_ELEMENT__NAME);
		createEAttribute(namedElementEClass, NAMED_ELEMENT__DESCRIPTION);

		identifierEClass = createEClass(IDENTIFIER);
		createEAttribute(identifierEClass, IDENTIFIER__UID);
		createEAttribute(identifierEClass, IDENTIFIER__UID_GENERATED);

		entityEClass = createEClass(ENTITY);

		networkInfrastructureEClass = createEClass(NETWORK_INFRASTRUCTURE);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__TRAFFIC);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__STRUCTURE);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__CONFIGURATION);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__ENTITY_TYPES);
		createEAttribute(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__DATA_CENTER_NAME);
		createEAttribute(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__META_MODEL_VERSION);

		networkStructureEClass = createEClass(NETWORK_STRUCTURE);
		createEReference(networkStructureEClass, NETWORK_STRUCTURE__NODES);
		createEReference(networkStructureEClass, NETWORK_STRUCTURE__LINKS);

		nodeEClass = createEClass(NODE);
		createEReference(nodeEClass, NODE__INTERFACES);
		createEReference(nodeEClass, NODE__SDNTYPE);
		createEAttribute(nodeEClass, NODE__IS_PHYSICAL);
		createEAttribute(nodeEClass, NODE__IS_PHYSICAL_DERIVED);
		createEReference(nodeEClass, NODE__HOSTS);
		createEReference(nodeEClass, NODE__IS_HOSTED_ON);
		createEReference(nodeEClass, NODE__END);
		createEReference(nodeEClass, NODE__INTERMEDIATE);
		createEReference(nodeEClass, NODE__ENTITY_TYPE);

		endEClass = createEClass(END);
		createEReference(endEClass, END__PERFORMANCE);
		createEReference(endEClass, END__SOFTWARE);
		createEReference(endEClass, END__NODE);
		createEAttribute(endEClass, END__NAME);

		intermediateEClass = createEClass(INTERMEDIATE);
		createEReference(intermediateEClass, INTERMEDIATE__PERFORMANCE);
		createEReference(intermediateEClass, INTERMEDIATE__NODE);
		createEAttribute(intermediateEClass, INTERMEDIATE__NAME);

		linkEClass = createEClass(LINK);
		createEReference(linkEClass, LINK__CONNECTS);
		createEReference(linkEClass, LINK__PERFORMANCE);
		createEAttribute(linkEClass, LINK__NAME_GENERATED);
		createEReference(linkEClass, LINK__ENTITY_TYPE);

		networkInterfaceEClass = createEClass(NETWORK_INTERFACE);
		createEReference(networkInterfaceEClass, NETWORK_INTERFACE__USED_PROTOCOL_STACK);
		createEReference(networkInterfaceEClass, NETWORK_INTERFACE__PERFORMANCE);
		createEReference(networkInterfaceEClass, NETWORK_INTERFACE__NODE);
		createEAttribute(networkInterfaceEClass, NETWORK_INTERFACE__NAME_GENERATED);
		createEReference(networkInterfaceEClass, NETWORK_INTERFACE__ENTITY_TYPE);

		networkTrafficEClass = createEClass(NETWORK_TRAFFIC);
		createEReference(networkTrafficEClass, NETWORK_TRAFFIC__FLOWS);
		createEReference(networkTrafficEClass, NETWORK_TRAFFIC__SOFTWARE);

		flowEClass = createEClass(FLOW);
		createEReference(flowEClass, FLOW__SOURCE_SOFTWARE);
		createEReference(flowEClass, FLOW__GENERATED_TRAFFIC);
		createEReference(flowEClass, FLOW__DESTINATION_SOFTWARE);
		createEReference(flowEClass, FLOW__DESTINATION_ADDRESSES);

		sdnControlFlowEClass = createEClass(SDN_CONTROL_FLOW);
		createEReference(sdnControlFlowEClass, SDN_CONTROL_FLOW__PARENT_FLOW);

		flowTrafficEClass = createEClass(FLOW_TRAFFIC);
		createEReference(flowTrafficEClass, FLOW_TRAFFIC__FLOW);
		createEAttribute(flowTrafficEClass, FLOW_TRAFFIC__NAME);

		genericFlowTrafficEClass = createEClass(GENERIC_FLOW_TRAFFIC);
		createEReference(genericFlowTrafficEClass, GENERIC_FLOW_TRAFFIC__DATA_SIZE);

		communicatingApplicationEClass = createEClass(COMMUNICATING_APPLICATION);
		createEReference(communicatingApplicationEClass, COMMUNICATING_APPLICATION__TRAFFIC_SOURCES);
		createEReference(communicatingApplicationEClass, COMMUNICATING_APPLICATION__DEPLOYED_ON);

		trafficSourceEClass = createEClass(TRAFFIC_SOURCE);
		createEReference(trafficSourceEClass, TRAFFIC_SOURCE__WORKLOAD);
		createEReference(trafficSourceEClass, TRAFFIC_SOURCE__SOFTWARE_COMPONENT);

		networkConfigurationEClass = createEClass(NETWORK_CONFIGURATION);
		createEReference(networkConfigurationEClass, NETWORK_CONFIGURATION__PROTOCOLS_AND_STACKS);
		createEReference(networkConfigurationEClass, NETWORK_CONFIGURATION__ROUTES);
		createEReference(networkConfigurationEClass, NETWORK_CONFIGURATION__RULES);

		protocolsRepositoryEClass = createEClass(PROTOCOLS_REPOSITORY);
		createEReference(protocolsRepositoryEClass, PROTOCOLS_REPOSITORY__STACKS);
		createEReference(protocolsRepositoryEClass, PROTOCOLS_REPOSITORY__PROTOCOLS);

		protocolStackEClass = createEClass(PROTOCOL_STACK);
		createEReference(protocolStackEClass, PROTOCOL_STACK__LAYERS);

		protocolLayerEClass = createEClass(PROTOCOL_LAYER);
		createEReference(protocolLayerEClass, PROTOCOL_LAYER__PROTOCOL);
		createEReference(protocolLayerEClass, PROTOCOL_LAYER__IS_CARRIED_BY);
		createEReference(protocolLayerEClass, PROTOCOL_LAYER__CARRIES);

		networkProtocolEClass = createEClass(NETWORK_PROTOCOL);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__MTU);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__HEADERS_LENGTH);

		routesRepositoryEClass = createEClass(ROUTES_REPOSITORY);
		createEReference(routesRepositoryEClass, ROUTES_REPOSITORY__ROUTES);
		createEReference(routesRepositoryEClass, ROUTES_REPOSITORY__FLOW_ROUTES);
		createEReference(routesRepositoryEClass, ROUTES_REPOSITORY__DIRECTIONS);

		directionEClass = createEClass(DIRECTION);
		createEReference(directionEClass, DIRECTION__ON_NODE);
		createEReference(directionEClass, DIRECTION__FLOW);
		createEReference(directionEClass, DIRECTION__VIA);
		createEAttribute(directionEClass, DIRECTION__DEFAULT);
		createEAttribute(directionEClass, DIRECTION__PROBABILITY);

		flowRouteEClass = createEClass(FLOW_ROUTE);
		createEReference(flowRouteEClass, FLOW_ROUTE__HOPS);
		createEReference(flowRouteEClass, FLOW_ROUTE__FLOW);
		createEReference(flowRouteEClass, FLOW_ROUTE__START);
		createEReference(flowRouteEClass, FLOW_ROUTE__END);
		createEAttribute(flowRouteEClass, FLOW_ROUTE__PROBABILITY);

		routeEClass = createEClass(ROUTE);
		createEReference(routeEClass, ROUTE__HOPS);
		createEReference(routeEClass, ROUTE__START);
		createEReference(routeEClass, ROUTE__END);

		hopEClass = createEClass(HOP);
		createEReference(hopEClass, HOP__NEXT_HOP);
		createEReference(hopEClass, HOP__INTERFACEREF);

		entityAddressEClass = createEClass(ENTITY_ADDRESS);
		createEAttribute(entityAddressEClass, ENTITY_ADDRESS__ADDRESS);
		createEReference(entityAddressEClass, ENTITY_ADDRESS__ADDRESS_GIVEN_BY);

		addressableEntityEClass = createEClass(ADDRESSABLE_ENTITY);
		createEReference(addressableEntityEClass, ADDRESSABLE_ENTITY__ADDRESSES);

		workloadEClass = createEClass(WORKLOAD);

		genericWorkloadEClass = createEClass(GENERIC_WORKLOAD);
		createEReference(genericWorkloadEClass, GENERIC_WORKLOAD__ACTIONS);

		abstractActionEClass = createEClass(ABSTRACT_ACTION);

		branchActionEClass = createEClass(BRANCH_ACTION);
		createEReference(branchActionEClass, BRANCH_ACTION__INTERN);

		loopActionEClass = createEClass(LOOP_ACTION);
		createEReference(loopActionEClass, LOOP_ACTION__INTERN);
		createEReference(loopActionEClass, LOOP_ACTION__NUM_ITERATIONS);

		sequenceActionEClass = createEClass(SEQUENCE_ACTION);
		createEReference(sequenceActionEClass, SEQUENCE_ACTION__INTERN);

		startActionEClass = createEClass(START_ACTION);

		stopActionEClass = createEClass(STOP_ACTION);

		transmitActionEClass = createEClass(TRANSMIT_ACTION);
		createEReference(transmitActionEClass, TRANSMIT_ACTION__FLOW_TRAFFIC);

		waitActionEClass = createEClass(WAIT_ACTION);
		createEReference(waitActionEClass, WAIT_ACTION__WAIT_TIME);

		performanceSpecificationEClass = createEClass(PERFORMANCE_SPECIFICATION);

		performanceLinkEClass = createEClass(PERFORMANCE_LINK);
		createEReference(performanceLinkEClass, PERFORMANCE_LINK__PROPAGATION_DELAY);
		createEReference(performanceLinkEClass, PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH);
		createEReference(performanceLinkEClass, PERFORMANCE_LINK__ENTITY_TYPE);

		performanceNetworkInterfaceEClass = createEClass(PERFORMANCE_NETWORK_INTERFACE);
		createEAttribute(performanceNetworkInterfaceEClass, PERFORMANCE_NETWORK_INTERFACE__IS_UP);
		createEAttribute(performanceNetworkInterfaceEClass, PERFORMANCE_NETWORK_INTERFACE__MTU);
		createEReference(performanceNetworkInterfaceEClass, PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME);
		createEReference(performanceNetworkInterfaceEClass, PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT);
		createEReference(performanceNetworkInterfaceEClass, PERFORMANCE_NETWORK_INTERFACE__ENTITY_TYPE);

		sdnFlowRuleEClass = createEClass(SDN_FLOW_RULE);
		createEReference(sdnFlowRuleEClass, SDN_FLOW_RULE__SDN_SWITCH);
		createEReference(sdnFlowRuleEClass, SDN_FLOW_RULE__FLOW);
		createEAttribute(sdnFlowRuleEClass, SDN_FLOW_RULE__PROBABILITY_HARDWARE);
		createEAttribute(sdnFlowRuleEClass, SDN_FLOW_RULE__PROBABILITY_SOFTWARE);
		createEAttribute(sdnFlowRuleEClass, SDN_FLOW_RULE__PROBABILITY_CONTROLLER);
		createEReference(sdnFlowRuleEClass, SDN_FLOW_RULE__CONTROLLER_APPLICATION);

		sdnControllerEClass = createEClass(SDN_CONTROLLER);
		createEReference(sdnControllerEClass, SDN_CONTROLLER__APPLICATIONS);
		createEReference(sdnControllerEClass, SDN_CONTROLLER__NODES);

		sdnControllerApplicationEClass = createEClass(SDN_CONTROLLER_APPLICATION);
		createEReference(sdnControllerApplicationEClass, SDN_CONTROLLER_APPLICATION__BELONGS_TO);
		createEAttribute(sdnControllerApplicationEClass, SDN_CONTROLLER_APPLICATION__IS_DEFAULT);
		createEReference(sdnControllerApplicationEClass, SDN_CONTROLLER_APPLICATION__RESPONSE_DELAY);

		iTypeEClass = createEClass(ITYPE);

		commonEClass = createEClass(COMMON);

		sdnEClass = createEClass(SDN);
		createEReference(sdnEClass, SDN__PERFORMANCE);
		createEReference(sdnEClass, SDN__CONTROLLER);
		createEReference(sdnEClass, SDN__OPEN_FLOW_END_POINT);

		intermediatePerformanceEClass = createEClass(INTERMEDIATE_PERFORMANCE);
		createEReference(intermediatePerformanceEClass, INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY);
		createEReference(intermediatePerformanceEClass, INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS);
		createEReference(intermediatePerformanceEClass, INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS);
		createEReference(intermediatePerformanceEClass, INTERMEDIATE_PERFORMANCE__ENTITY_TYPE);

		endPerformanceEClass = createEClass(END_PERFORMANCE);
		createEReference(endPerformanceEClass, END_PERFORMANCE__SOFTWARE_LAYERS_DELAY);
		createEReference(endPerformanceEClass, END_PERFORMANCE__ENTITY_TYPE);

		performanceSdnNodeEClass = createEClass(PERFORMANCE_SDN_NODE);
		createEReference(performanceSdnNodeEClass, PERFORMANCE_SDN_NODE__SOFTWARE_SWITCHING_PERFORMANCE);
		createEReference(performanceSdnNodeEClass, PERFORMANCE_SDN_NODE__HARDWARE_SWITCHING_PERFORMANCE);
		createEReference(performanceSdnNodeEClass, PERFORMANCE_SDN_NODE__ENTITY_TYPE);

		dniUnitEClass = createEClass(DNI_UNIT);

		speedUnitEClass = createEClass(SPEED_UNIT);
		createEAttribute(speedUnitEClass, SPEED_UNIT__UNIT);
		createEAttribute(speedUnitEClass, SPEED_UNIT__PREFIX);

		dataUnitEClass = createEClass(DATA_UNIT);
		createEAttribute(dataUnitEClass, DATA_UNIT__PREFIX);

		timeUnitEClass = createEClass(TIME_UNIT);
		createEAttribute(timeUnitEClass, TIME_UNIT__UNIT);

		dependencyEClass = createEClass(DEPENDENCY);
		createEReference(dependencyEClass, DEPENDENCY__UNIT);

		variableEClass = createEClass(VARIABLE);

		functionEClass = createEClass(FUNCTION);

		constantDoubleVariableEClass = createEClass(CONSTANT_DOUBLE_VARIABLE);
		createEAttribute(constantDoubleVariableEClass, CONSTANT_DOUBLE_VARIABLE__VALUE);

		constantLongVariableEClass = createEClass(CONSTANT_LONG_VARIABLE);
		createEAttribute(constantLongVariableEClass, CONSTANT_LONG_VARIABLE__VALUE);

		randomVariableEClass = createEClass(RANDOM_VARIABLE);
		createEReference(randomVariableEClass, RANDOM_VARIABLE__CDF);

		floatCoordinateEClass = createEClass(FLOAT_COORDINATE);
		createEAttribute(floatCoordinateEClass, FLOAT_COORDINATE__X);
		createEAttribute(floatCoordinateEClass, FLOAT_COORDINATE__Y);

		discreteFunctionEClass = createEClass(DISCRETE_FUNCTION);
		createEReference(discreteFunctionEClass, DISCRETE_FUNCTION__VALS);

		exponentialFunctionEClass = createEClass(EXPONENTIAL_FUNCTION);
		createEAttribute(exponentialFunctionEClass, EXPONENTIAL_FUNCTION__LAMBDA);

		entityTypesEClass = createEClass(ENTITY_TYPES);
		createEReference(entityTypesEClass, ENTITY_TYPES__TYPES);

		iTypedEntityEClass = createEClass(ITYPED_ENTITY);

		nodeTypeEClass = createEClass(NODE_TYPE);
		createEReference(nodeTypeEClass, NODE_TYPE__ENTITIES);

		endPerformanceTypeEClass = createEClass(END_PERFORMANCE_TYPE);
		createEReference(endPerformanceTypeEClass, END_PERFORMANCE_TYPE__ENTITIES);

		intermediatePerformanceTypeEClass = createEClass(INTERMEDIATE_PERFORMANCE_TYPE);
		createEReference(intermediatePerformanceTypeEClass, INTERMEDIATE_PERFORMANCE_TYPE__ENTITIES);

		sdnNodePerformanceTypeEClass = createEClass(SDN_NODE_PERFORMANCE_TYPE);
		createEReference(sdnNodePerformanceTypeEClass, SDN_NODE_PERFORMANCE_TYPE__ENTITIES);

		networkInterfaceTypeEClass = createEClass(NETWORK_INTERFACE_TYPE);
		createEReference(networkInterfaceTypeEClass, NETWORK_INTERFACE_TYPE__ENTITIES);

		networkInterfacePerformanceTypeEClass = createEClass(NETWORK_INTERFACE_PERFORMANCE_TYPE);
		createEReference(networkInterfacePerformanceTypeEClass, NETWORK_INTERFACE_PERFORMANCE_TYPE__ENTITIES);

		linkTypeEClass = createEClass(LINK_TYPE);
		createEReference(linkTypeEClass, LINK_TYPE__ENTITIES);

		linkPerformanceTypeEClass = createEClass(LINK_PERFORMANCE_TYPE);
		createEReference(linkPerformanceTypeEClass, LINK_PERFORMANCE_TYPE__ENTITIES);

		// Create enums
		unitPrefixEEnum = createEEnum(UNIT_PREFIX);
		speedEEnum = createEEnum(SPEED);
		timeEEnum = createEEnum(TIME);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		entityEClass.getESuperTypes().add(this.getIdentifier());
		entityEClass.getESuperTypes().add(this.getNamedElement());
		nodeEClass.getESuperTypes().add(this.getEntity());
		endEClass.getESuperTypes().add(this.getIdentifier());
		intermediateEClass.getESuperTypes().add(this.getIdentifier());
		linkEClass.getESuperTypes().add(this.getEntity());
		networkInterfaceEClass.getESuperTypes().add(this.getAddressableEntity());
		networkInterfaceEClass.getESuperTypes().add(this.getNamedElement());
		networkInterfaceEClass.getESuperTypes().add(this.getEntity());
		flowEClass.getESuperTypes().add(this.getEntity());
		sdnControlFlowEClass.getESuperTypes().add(this.getFlow());
		genericFlowTrafficEClass.getESuperTypes().add(this.getFlowTraffic());
		communicatingApplicationEClass.getESuperTypes().add(this.getEntity());
		trafficSourceEClass.getESuperTypes().add(this.getEntity());
		trafficSourceEClass.getESuperTypes().add(this.getAddressableEntity());
		protocolStackEClass.getESuperTypes().add(this.getEntity());
		protocolLayerEClass.getESuperTypes().add(this.getEntity());
		networkProtocolEClass.getESuperTypes().add(this.getEntity());
		directionEClass.getESuperTypes().add(this.getEntity());
		flowRouteEClass.getESuperTypes().add(this.getEntity());
		routeEClass.getESuperTypes().add(this.getEntity());
		genericWorkloadEClass.getESuperTypes().add(this.getWorkload());
		branchActionEClass.getESuperTypes().add(this.getAbstractAction());
		loopActionEClass.getESuperTypes().add(this.getAbstractAction());
		sequenceActionEClass.getESuperTypes().add(this.getAbstractAction());
		startActionEClass.getESuperTypes().add(this.getAbstractAction());
		stopActionEClass.getESuperTypes().add(this.getAbstractAction());
		transmitActionEClass.getESuperTypes().add(this.getAbstractAction());
		waitActionEClass.getESuperTypes().add(this.getAbstractAction());
		performanceLinkEClass.getESuperTypes().add(this.getPerformanceSpecification());
		performanceNetworkInterfaceEClass.getESuperTypes().add(this.getPerformanceSpecification());
		sdnControllerEClass.getESuperTypes().add(this.getCommunicatingApplication());
		sdnControllerApplicationEClass.getESuperTypes().add(this.getCommunicatingApplication());
		commonEClass.getESuperTypes().add(this.getIType());
		sdnEClass.getESuperTypes().add(this.getIType());
		intermediatePerformanceEClass.getESuperTypes().add(this.getPerformanceSpecification());
		endPerformanceEClass.getESuperTypes().add(this.getPerformanceSpecification());
		performanceSdnNodeEClass.getESuperTypes().add(this.getPerformanceSpecification());
		speedUnitEClass.getESuperTypes().add(this.getDNIUnit());
		dataUnitEClass.getESuperTypes().add(this.getDNIUnit());
		timeUnitEClass.getESuperTypes().add(this.getDNIUnit());
		variableEClass.getESuperTypes().add(this.getDependency());
		functionEClass.getESuperTypes().add(this.getDependency());
		constantDoubleVariableEClass.getESuperTypes().add(this.getVariable());
		constantLongVariableEClass.getESuperTypes().add(this.getVariable());
		randomVariableEClass.getESuperTypes().add(this.getVariable());
		discreteFunctionEClass.getESuperTypes().add(this.getFunction());
		exponentialFunctionEClass.getESuperTypes().add(this.getFunction());
		iTypedEntityEClass.getESuperTypes().add(this.getNamedElement());
		iTypedEntityEClass.getESuperTypes().add(this.getIdentifier());
		nodeTypeEClass.getESuperTypes().add(this.getITypedEntity());
		endPerformanceTypeEClass.getESuperTypes().add(this.getITypedEntity());
		intermediatePerformanceTypeEClass.getESuperTypes().add(this.getITypedEntity());
		sdnNodePerformanceTypeEClass.getESuperTypes().add(this.getITypedEntity());
		networkInterfaceTypeEClass.getESuperTypes().add(this.getITypedEntity());
		networkInterfacePerformanceTypeEClass.getESuperTypes().add(this.getITypedEntity());
		linkTypeEClass.getESuperTypes().add(this.getITypedEntity());
		linkPerformanceTypeEClass.getESuperTypes().add(this.getITypedEntity());

		// Initialize classes, features, and operations; add parameters
		initEClass(namedElementEClass, NamedElement.class, "NamedElement", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNamedElement_Name(), theEcorePackage.getEString(), "name", null, 1, 1, NamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNamedElement_Description(), theEcorePackage.getEString(), "description", null, 0, 1, NamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(identifierEClass, Identifier.class, "Identifier", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIdentifier_Uid(), theEcorePackage.getEString(), "uid", null, 0, 1, Identifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdentifier_Uid_generated(), theEcorePackage.getEString(), "uid_generated", null, 0, 1, Identifier.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(entityEClass, Entity.class, "Entity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(networkInfrastructureEClass, NetworkInfrastructure.class, "NetworkInfrastructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkInfrastructure_Traffic(), this.getNetworkTraffic(), null, "traffic", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInfrastructure_Structure(), this.getNetworkStructure(), null, "structure", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInfrastructure_Configuration(), this.getNetworkConfiguration(), null, "configuration", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInfrastructure_EntityTypes(), this.getEntityTypes(), null, "entityTypes", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkInfrastructure_DataCenterName(), theEcorePackage.getEString(), "dataCenterName", null, 0, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkInfrastructure_MetaModelVersion(), theEcorePackage.getEString(), "metaModelVersion", null, 0, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkStructureEClass, NetworkStructure.class, "NetworkStructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkStructure_Nodes(), this.getNode(), null, "nodes", null, 1, -1, NetworkStructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkStructure_Links(), this.getLink(), null, "links", null, 0, -1, NetworkStructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(nodeEClass, Node.class, "Node", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNode_Interfaces(), this.getNetworkInterface(), this.getNetworkInterface_Node(), "interfaces", null, 0, -1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNode_Sdntype(), this.getIType(), null, "sdntype", null, 1, 1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNode_IsPhysical(), theEcorePackage.getEBoolean(), "isPhysical", "true", 0, 1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNode_IsPhysical_derived(), theEcorePackage.getEBoolean(), "isPhysical_derived", null, 0, 1, Node.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getNode_Hosts(), this.getNode(), this.getNode_IsHostedOn(), "hosts", null, 0, -1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNode_IsHostedOn(), this.getNode(), this.getNode_Hosts(), "isHostedOn", null, 0, 1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNode_End(), this.getEnd(), this.getEnd_Node(), "end", null, 0, 1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNode_Intermediate(), this.getIntermediate(), this.getIntermediate_Node(), "intermediate", null, 0, 1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNode_EntityType(), this.getNodeType(), this.getNodeType_Entities(), "entityType", null, 0, 1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(endEClass, End.class, "End", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEnd_Performance(), this.getEndPerformance(), null, "performance", null, 0, 1, End.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnd_Software(), this.getCommunicatingApplication(), this.getCommunicatingApplication_DeployedOn(), "software", null, 0, -1, End.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEnd_Node(), this.getNode(), this.getNode_End(), "node", null, 0, 1, End.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEnd_Name(), theEcorePackage.getEString(), "name", null, 0, 1, End.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(intermediateEClass, Intermediate.class, "Intermediate", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIntermediate_Performance(), this.getIntermediatePerformance(), null, "performance", null, 0, 1, Intermediate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIntermediate_Node(), this.getNode(), this.getNode_Intermediate(), "node", null, 0, 1, Intermediate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIntermediate_Name(), theEcorePackage.getEString(), "name", null, 0, 1, Intermediate.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(linkEClass, Link.class, "Link", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLink_Connects(), this.getNetworkInterface(), null, "connects", null, 2, 2, Link.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLink_Performance(), this.getPerformanceLink(), null, "performance", null, 0, 1, Link.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLink_Name_generated(), theEcorePackage.getEString(), "name_generated", null, 0, 1, Link.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getLink_EntityType(), this.getLinkType(), this.getLinkType_Entities(), "entityType", null, 0, 1, Link.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkInterfaceEClass, NetworkInterface.class, "NetworkInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkInterface_UsedProtocolStack(), this.getProtocolStack(), null, "usedProtocolStack", null, 1, 1, NetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInterface_Performance(), this.getPerformanceNetworkInterface(), null, "performance", null, 0, 1, NetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInterface_Node(), this.getNode(), this.getNode_Interfaces(), "node", null, 0, 1, NetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkInterface_Name_generated(), theEcorePackage.getEString(), "name_generated", null, 0, 1, NetworkInterface.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInterface_EntityType(), this.getNetworkInterfaceType(), this.getNetworkInterfaceType_Entities(), "entityType", null, 0, 1, NetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkTrafficEClass, NetworkTraffic.class, "NetworkTraffic", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkTraffic_Flows(), this.getFlow(), null, "flows", null, 0, -1, NetworkTraffic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkTraffic_Software(), this.getCommunicatingApplication(), null, "software", null, 0, -1, NetworkTraffic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowEClass, Flow.class, "Flow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFlow_SourceSoftware(), this.getCommunicatingApplication(), null, "sourceSoftware", null, 1, 1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlow_GeneratedTraffic(), this.getFlowTraffic(), this.getFlowTraffic_Flow(), "generatedTraffic", null, 0, -1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlow_DestinationSoftware(), this.getCommunicatingApplication(), null, "destinationSoftware", null, 1, -1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlow_DestinationAddresses(), this.getEntityAddress(), null, "destinationAddresses", null, 0, -1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sdnControlFlowEClass, SdnControlFlow.class, "SdnControlFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSdnControlFlow_ParentFlow(), this.getFlow(), null, "parentFlow", null, 1, 1, SdnControlFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowTrafficEClass, FlowTraffic.class, "FlowTraffic", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFlowTraffic_Flow(), this.getFlow(), this.getFlow_GeneratedTraffic(), "flow", null, 0, 1, FlowTraffic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFlowTraffic_Name(), theEcorePackage.getEString(), "name", null, 0, 1, FlowTraffic.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(genericFlowTrafficEClass, GenericFlowTraffic.class, "GenericFlowTraffic", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGenericFlowTraffic_DataSize(), this.getDependency(), null, "dataSize", null, 1, 1, GenericFlowTraffic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(communicatingApplicationEClass, CommunicatingApplication.class, "CommunicatingApplication", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCommunicatingApplication_TrafficSources(), this.getTrafficSource(), this.getTrafficSource_SoftwareComponent(), "trafficSources", null, 0, -1, CommunicatingApplication.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCommunicatingApplication_DeployedOn(), this.getEnd(), this.getEnd_Software(), "deployedOn", null, 0, 1, CommunicatingApplication.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trafficSourceEClass, TrafficSource.class, "TrafficSource", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTrafficSource_Workload(), this.getWorkload(), null, "workload", null, 1, -1, TrafficSource.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTrafficSource_SoftwareComponent(), this.getCommunicatingApplication(), this.getCommunicatingApplication_TrafficSources(), "softwareComponent", null, 1, 1, TrafficSource.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkConfigurationEClass, NetworkConfiguration.class, "NetworkConfiguration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkConfiguration_ProtocolsAndStacks(), this.getProtocolsRepository(), null, "protocolsAndStacks", null, 1, 1, NetworkConfiguration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkConfiguration_Routes(), this.getRoutesRepository(), null, "routes", null, 1, 1, NetworkConfiguration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkConfiguration_Rules(), this.getSdnFlowRule(), null, "rules", null, 0, -1, NetworkConfiguration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(protocolsRepositoryEClass, ProtocolsRepository.class, "ProtocolsRepository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getProtocolsRepository_Stacks(), this.getProtocolStack(), null, "stacks", null, 0, -1, ProtocolsRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProtocolsRepository_Protocols(), this.getNetworkProtocol(), null, "protocols", null, 1, -1, ProtocolsRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(protocolStackEClass, ProtocolStack.class, "ProtocolStack", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getProtocolStack_Layers(), this.getProtocolLayer(), null, "layers", null, 1, -1, ProtocolStack.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(protocolLayerEClass, ProtocolLayer.class, "ProtocolLayer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getProtocolLayer_Protocol(), this.getNetworkProtocol(), null, "protocol", null, 1, 1, ProtocolLayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProtocolLayer_IsCarriedBy(), this.getProtocolLayer(), this.getProtocolLayer_Carries(), "isCarriedBy", null, 0, 1, ProtocolLayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProtocolLayer_Carries(), this.getProtocolLayer(), this.getProtocolLayer_IsCarriedBy(), "carries", null, 0, 1, ProtocolLayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkProtocolEClass, NetworkProtocol.class, "NetworkProtocol", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNetworkProtocol_Mtu(), theEcorePackage.getEInt(), "mtu", "1500", 1, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkProtocol_HeadersLength(), theEcorePackage.getEInt(), "headersLength", "40", 1, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(routesRepositoryEClass, RoutesRepository.class, "RoutesRepository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRoutesRepository_Routes(), this.getRoute(), null, "routes", null, 0, -1, RoutesRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRoutesRepository_FlowRoutes(), this.getFlowRoute(), null, "flowRoutes", null, 0, -1, RoutesRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRoutesRepository_Directions(), this.getDirection(), null, "directions", null, 0, -1, RoutesRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(directionEClass, Direction.class, "Direction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDirection_OnNode(), this.getNode(), null, "onNode", null, 1, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDirection_Flow(), this.getFlow(), null, "flow", null, 1, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDirection_Via(), this.getNetworkInterface(), null, "via", null, 1, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDirection_Default(), theEcorePackage.getEInt(), "default", "0", 0, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDirection_Probability(), theEcorePackage.getEFloat(), "probability", "1.0", 1, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowRouteEClass, FlowRoute.class, "FlowRoute", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFlowRoute_Hops(), this.getHop(), null, "hops", null, 0, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlowRoute_Flow(), this.getFlow(), null, "flow", null, 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlowRoute_Start(), this.getNetworkInterface(), null, "start", null, 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlowRoute_End(), this.getNetworkInterface(), null, "end", null, 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFlowRoute_Probability(), theEcorePackage.getEFloat(), "probability", "1.0", 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(routeEClass, Route.class, "Route", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRoute_Hops(), this.getHop(), null, "hops", null, 0, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRoute_Start(), this.getNetworkInterface(), null, "start", null, 1, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRoute_End(), this.getNetworkInterface(), null, "end", null, 1, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hopEClass, Hop.class, "Hop", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getHop_NextHop(), this.getHop(), null, "nextHop", null, 0, 1, Hop.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHop_Interfaceref(), this.getNetworkInterface(), null, "interfaceref", null, 1, 1, Hop.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(entityAddressEClass, EntityAddress.class, "EntityAddress", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEntityAddress_Address(), theEcorePackage.getEString(), "address", "x.x.x.x", 0, 1, EntityAddress.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEntityAddress_AddressGivenBy(), this.getNetworkProtocol(), null, "addressGivenBy", null, 0, 1, EntityAddress.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(addressableEntityEClass, AddressableEntity.class, "AddressableEntity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAddressableEntity_Addresses(), this.getEntityAddress(), null, "addresses", null, 0, -1, AddressableEntity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(workloadEClass, Workload.class, "Workload", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(genericWorkloadEClass, GenericWorkload.class, "GenericWorkload", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGenericWorkload_Actions(), this.getAbstractAction(), null, "actions", null, 0, -1, GenericWorkload.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(abstractActionEClass, AbstractAction.class, "AbstractAction", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(branchActionEClass, BranchAction.class, "BranchAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchAction_Intern(), this.getAbstractAction(), null, "intern", null, 1, -1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(loopActionEClass, LoopAction.class, "LoopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopAction_Intern(), this.getAbstractAction(), null, "intern", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLoopAction_NumIterations(), this.getDependency(), null, "numIterations", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sequenceActionEClass, SequenceAction.class, "SequenceAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSequenceAction_Intern(), this.getAbstractAction(), null, "intern", null, 1, -1, SequenceAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(startActionEClass, StartAction.class, "StartAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(stopActionEClass, StopAction.class, "StopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(transmitActionEClass, TransmitAction.class, "TransmitAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTransmitAction_FlowTraffic(), this.getFlowTraffic(), null, "flowTraffic", null, 1, 1, TransmitAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(waitActionEClass, WaitAction.class, "WaitAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWaitAction_WaitTime(), this.getDependency(), null, "waitTime", null, 1, 1, WaitAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(performanceSpecificationEClass, PerformanceSpecification.class, "PerformanceSpecification", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(performanceLinkEClass, PerformanceLink.class, "PerformanceLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPerformanceLink_PropagationDelay(), this.getDependency(), null, "propagationDelay", null, 1, 1, PerformanceLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceLink_MaxSupportedBandwidth(), this.getDependency(), null, "maxSupportedBandwidth", null, 1, 1, PerformanceLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceLink_EntityType(), this.getLinkPerformanceType(), this.getLinkPerformanceType_Entities(), "entityType", null, 0, 1, PerformanceLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(performanceNetworkInterfaceEClass, PerformanceNetworkInterface.class, "PerformanceNetworkInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPerformanceNetworkInterface_IsUp(), theEcorePackage.getEBoolean(), "isUp", "true", 0, 1, PerformanceNetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerformanceNetworkInterface_MTU(), theEcorePackage.getEInt(), "MTU", "1500", 1, 1, PerformanceNetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceNetworkInterface_PacketProcessingTime(), this.getDependency(), null, "packetProcessingTime", null, 1, 1, PerformanceNetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceNetworkInterface_InterfaceThroughput(), this.getVariable(), null, "interfaceThroughput", null, 1, 1, PerformanceNetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceNetworkInterface_EntityType(), this.getNetworkInterfacePerformanceType(), this.getNetworkInterfacePerformanceType_Entities(), "entityType", null, 0, 1, PerformanceNetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sdnFlowRuleEClass, SdnFlowRule.class, "SdnFlowRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSdnFlowRule_SdnSwitch(), this.getNode(), null, "sdnSwitch", null, 1, 1, SdnFlowRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSdnFlowRule_Flow(), this.getFlow(), null, "flow", null, 1, 1, SdnFlowRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdnFlowRule_ProbabilityHardware(), theEcorePackage.getEFloat(), "probabilityHardware", "1.0", 1, 1, SdnFlowRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdnFlowRule_ProbabilitySoftware(), theEcorePackage.getEFloat(), "probabilitySoftware", "0.0", 0, 1, SdnFlowRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdnFlowRule_ProbabilityController(), theEcorePackage.getEFloat(), "probabilityController", "0.0", 0, 1, SdnFlowRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSdnFlowRule_ControllerApplication(), this.getSdnControllerApplication(), null, "controllerApplication", null, 0, 1, SdnFlowRule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sdnControllerEClass, SdnController.class, "SdnController", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSdnController_Applications(), this.getSdnControllerApplication(), this.getSdnControllerApplication_BelongsTo(), "applications", null, 0, -1, SdnController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSdnController_Nodes(), this.getSDN(), this.getSDN_Controller(), "nodes", null, 0, -1, SdnController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sdnControllerApplicationEClass, SdnControllerApplication.class, "SdnControllerApplication", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSdnControllerApplication_BelongsTo(), this.getSdnController(), this.getSdnController_Applications(), "belongsTo", null, 0, 1, SdnControllerApplication.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdnControllerApplication_IsDefault(), theEcorePackage.getEBoolean(), "isDefault", "false", 1, 1, SdnControllerApplication.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSdnControllerApplication_ResponseDelay(), this.getDependency(), null, "responseDelay", null, 0, 1, SdnControllerApplication.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iTypeEClass, IType.class, "IType", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(commonEClass, Common.class, "Common", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sdnEClass, tools.descartes.dni.dnimm3.SDN.class, "SDN", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSDN_Performance(), this.getPerformanceSdnNode(), null, "performance", null, 1, 1, tools.descartes.dni.dnimm3.SDN.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSDN_Controller(), this.getSdnController(), this.getSdnController_Nodes(), "controller", null, 1, -1, tools.descartes.dni.dnimm3.SDN.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSDN_OpenFlowEndPoint(), this.getCommunicatingApplication(), null, "openFlowEndPoint", null, 1, 1, tools.descartes.dni.dnimm3.SDN.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(intermediatePerformanceEClass, IntermediatePerformance.class, "IntermediatePerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIntermediatePerformance_ForwardingLatency(), this.getDependency(), null, "forwardingLatency", null, 1, 1, IntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIntermediatePerformance_ForwardingBandwidthBPS(), this.getDependency(), null, "forwardingBandwidthBPS", null, 1, 1, IntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIntermediatePerformance_SwitchingCapacityPPS(), this.getDependency(), null, "switchingCapacityPPS", null, 1, 1, IntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIntermediatePerformance_EntityType(), this.getIntermediatePerformanceType(), this.getIntermediatePerformanceType_Entities(), "entityType", null, 0, 1, IntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(endPerformanceEClass, EndPerformance.class, "EndPerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEndPerformance_SoftwareLayersDelay(), this.getDependency(), null, "softwareLayersDelay", null, 1, 1, EndPerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEndPerformance_EntityType(), this.getEndPerformanceType(), this.getEndPerformanceType_Entities(), "entityType", null, 0, 1, EndPerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(performanceSdnNodeEClass, PerformanceSdnNode.class, "PerformanceSdnNode", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPerformanceSdnNode_SoftwareSwitchingPerformance(), this.getIntermediatePerformance(), null, "softwareSwitchingPerformance", null, 0, 1, PerformanceSdnNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceSdnNode_HardwareSwitchingPerformance(), this.getIntermediatePerformance(), null, "hardwareSwitchingPerformance", null, 0, 1, PerformanceSdnNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPerformanceSdnNode_EntityType(), this.getSdnNodePerformanceType(), this.getSdnNodePerformanceType_Entities(), "entityType", null, 0, 1, PerformanceSdnNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dniUnitEClass, DNIUnit.class, "DNIUnit", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(speedUnitEClass, SpeedUnit.class, "SpeedUnit", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSpeedUnit_Unit(), this.getSpeed(), "unit", null, 1, 1, SpeedUnit.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getSpeedUnit_Prefix(), this.getUnitPrefix(), "prefix", "none", 1, 1, SpeedUnit.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(dataUnitEClass, DataUnit.class, "DataUnit", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDataUnit_Prefix(), this.getUnitPrefix(), "prefix", "none", 1, 1, DataUnit.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(timeUnitEClass, TimeUnit.class, "TimeUnit", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTimeUnit_Unit(), this.getTime(), "unit", null, 0, 1, TimeUnit.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dependencyEClass, Dependency.class, "Dependency", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDependency_Unit(), this.getDNIUnit(), null, "unit", null, 0, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(variableEClass, Variable.class, "Variable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(functionEClass, Function.class, "Function", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(constantDoubleVariableEClass, ConstantDoubleVariable.class, "ConstantDoubleVariable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConstantDoubleVariable_Value(), theEcorePackage.getEDouble(), "value", null, 1, 1, ConstantDoubleVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(constantLongVariableEClass, ConstantLongVariable.class, "ConstantLongVariable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConstantLongVariable_Value(), theEcorePackage.getELong(), "value", null, 1, 1, ConstantLongVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(randomVariableEClass, RandomVariable.class, "RandomVariable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRandomVariable_Cdf(), this.getFunction(), null, "cdf", null, 1, 1, RandomVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(floatCoordinateEClass, FloatCoordinate.class, "FloatCoordinate", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFloatCoordinate_X(), theEcorePackage.getEDouble(), "x", null, 0, 1, FloatCoordinate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFloatCoordinate_Y(), theEcorePackage.getEDouble(), "y", null, 0, 1, FloatCoordinate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(discreteFunctionEClass, DiscreteFunction.class, "DiscreteFunction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDiscreteFunction_Vals(), this.getFloatCoordinate(), null, "vals", null, 1, -1, DiscreteFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(exponentialFunctionEClass, ExponentialFunction.class, "ExponentialFunction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getExponentialFunction_Lambda(), theEcorePackage.getEDouble(), "lambda", null, 0, 1, ExponentialFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(entityTypesEClass, EntityTypes.class, "EntityTypes", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEntityTypes_Types(), this.getITypedEntity(), null, "types", null, 0, -1, EntityTypes.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iTypedEntityEClass, ITypedEntity.class, "ITypedEntity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(nodeTypeEClass, NodeType.class, "NodeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNodeType_Entities(), this.getNode(), this.getNode_EntityType(), "entities", null, 0, -1, NodeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(endPerformanceTypeEClass, EndPerformanceType.class, "EndPerformanceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEndPerformanceType_Entities(), this.getEndPerformance(), this.getEndPerformance_EntityType(), "entities", null, 0, -1, EndPerformanceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(intermediatePerformanceTypeEClass, IntermediatePerformanceType.class, "IntermediatePerformanceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIntermediatePerformanceType_Entities(), this.getIntermediatePerformance(), this.getIntermediatePerformance_EntityType(), "entities", null, 0, -1, IntermediatePerformanceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sdnNodePerformanceTypeEClass, SdnNodePerformanceType.class, "SdnNodePerformanceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSdnNodePerformanceType_Entities(), this.getPerformanceSdnNode(), this.getPerformanceSdnNode_EntityType(), "entities", null, 0, -1, SdnNodePerformanceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkInterfaceTypeEClass, NetworkInterfaceType.class, "NetworkInterfaceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkInterfaceType_Entities(), this.getNetworkInterface(), this.getNetworkInterface_EntityType(), "entities", null, 0, -1, NetworkInterfaceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkInterfacePerformanceTypeEClass, NetworkInterfacePerformanceType.class, "NetworkInterfacePerformanceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkInterfacePerformanceType_Entities(), this.getPerformanceNetworkInterface(), this.getPerformanceNetworkInterface_EntityType(), "entities", null, 0, -1, NetworkInterfacePerformanceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(linkTypeEClass, LinkType.class, "LinkType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLinkType_Entities(), this.getLink(), this.getLink_EntityType(), "entities", null, 0, -1, LinkType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(linkPerformanceTypeEClass, LinkPerformanceType.class, "LinkPerformanceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLinkPerformanceType_Entities(), this.getPerformanceLink(), this.getPerformanceLink_EntityType(), "entities", null, 0, -1, LinkPerformanceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(unitPrefixEEnum, UnitPrefix.class, "UnitPrefix");
		addEEnumLiteral(unitPrefixEEnum, UnitPrefix.NONE);
		addEEnumLiteral(unitPrefixEEnum, UnitPrefix.K);
		addEEnumLiteral(unitPrefixEEnum, UnitPrefix.M);
		addEEnumLiteral(unitPrefixEEnum, UnitPrefix.G);

		initEEnum(speedEEnum, Speed.class, "Speed");
		addEEnumLiteral(speedEEnum, Speed.BYTES_PER_SEC);
		addEEnumLiteral(speedEEnum, Speed.BITS_PER_SEC);
		addEEnumLiteral(speedEEnum, Speed.PACKETS_PER_SEC);

		initEEnum(timeEEnum, Time.class, "Time");
		addEEnumLiteral(timeEEnum, Time.SECONDS);
		addEEnumLiteral(timeEEnum, Time.MILLISECONDS);
		addEEnumLiteral(timeEEnum, Time.MICROSECONDS);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2011/Xcore
		createXcoreAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2011/Xcore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createXcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2011/Xcore";	
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "Pivot", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
		   });
	}

} //DNIPackageImpl
